Subject: [Roll] Deprecating DCO status

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Wed, 28 Oct 2020 09:13:52 +0000

Hello Rahul:

Attracting your attention on the particular point below in Alvaro's AD review of unaware leaves:

> > So we should update the NPDAO draft and remove that entry shouldn't we?

> > Note that NPDAO is already in missref because of this draft

> > https://www.rfc-editor.org/cluster_info.php?cid=C310

> Yes.

> Also, the specification of the DAO-ACK needs to be changed to at least make it

> clear that the "DCO-ACK Status" field refers to the "RPL Status".

> About deprecating the registry...  We should ask IANA what to do: they already

> created the registry, but the efficient-npdao hasn't been published as an

> RFC.  I don't know if we just delete §6.2 or if we have to formally deprecate the

> registry (possible in this document).

> Please ack to this to make sure we're in sync before asking IANA.

The change Alvaro and I want to make in the efficient npdao draft is that the DCO status is now of the same type as the RPL status in DAO ACK, and should be specified as such in https://tools.ietf.org/html/draft-ietf-roll-efficient-npdao-18#section-4.3.4

Which means that we do not need the registry that we ask for in https://tools.ietf.org/html/draft-ietf-roll-efficient-npdao-18#page-17

Do you agree?

Keep safe!

Pascal

---

From: Rahul Jadhav <[email-masked]>
Date: Wed, 28 Oct 2020 18:13:25 +0530

Hi Pascal, Alvaro,

I am mostly clear on the changes required. Please find attached an
HTML-diff for the suggested changes.
The only concern for me was if we remove the registry where would the
Status 1 indicating "No routing-entry for the indicated Target found".
But I see that unaware-leaves has made an update to its IANA section
to include this status. So it works.
Thus, I am referencing unaware-leaves for Status values.

Regards,
Rahul

On Wed, 28 Oct 2020 at 14:44, Pascal Thubert (pthubert)
<[email-masked]> wrote:
>
> Hello Rahul:
>
>
>
> Attracting your attention on the particular point below in Alvaro’s AD review of unaware leaves:
>
>
>

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Wed, 28 Oct 2020 15:06:16 +0000

Hello Rahul

I believe that you need to indicate that the status is a RPL Status and refer to section 6.5.1. of RPL "  Format of the DAO-ACK Base Object".  I'm sure Alvaro will propose an improvement but my knee jerk:

Before:

Status: Indicates the completion status.  Section 12.5 of	[I-D.ietf-roll-unaware-leaves] defines the status values.  A value of	0 is defined as unqualified acceptance.  A value of 1 is defined  as "No routing-entry for the indicated Target found".

After: 

Status: RPL Status indicating the completion. The RPL Status is defined in section 6.5.1. of  [RFC 6550] and updated in 
section 6.3 of [I-D.ietf-roll-unaware-leaves].  This specification adds the RPL rejection value ('E' flag set and 'A' flag not set) of 1, defined  as "No routing-entry for the indicated Target found".

Works?

Take care;

Pascal

> -----Original Message-----
> From: Rahul Jadhav <[email-masked]>
> Sent: mercredi 28 octobre 2020 13:43
> To: Pascal Thubert (pthubert) <[email-masked]>
> Cc: Alvaro Retana <[email-masked]>; [email-masked]; Routing
> Over Low power and Lossy networks <[email-masked]>
> Subject: Re: Deprecating DCO status
> 
> Hi Pascal, Alvaro,
> 
> I am mostly clear on the changes required. Please find attached an HTML-diff
> for the suggested changes.
> The only concern for me was if we remove the registry where would the Status
> 1 indicating "No routing-entry for the indicated Target found".
> But I see that unaware-leaves has made an update to its IANA section to
> include this status. So it works.
> > The change Alvaro and I want to make in the efficient npdao draft is
> > that the DCO status is now of the same type as the RPL status in DAO
> > ACK, and should be specified as such in
> > https://tools.ietf.org/html/draft-ietf-roll-efficient-npdao-18#section
> > -4.3.4
> >
> > Which means that we do not need the registry that we ask for in
> > https://tools.ietf.org/html/draft-ietf-roll-efficient-npdao-18#page-17
> >
> >
> >
> > Do you agree?
> >
> >
> >
> > Keep safe!
> >
> >
> >
> > Pascal
> >
> >

---

From: Alvaro Retana <[email-masked]>
Date: Wed, 28 Oct 2020 08:17:07 -0700

Hi!

The last part (“This specification adds…”) is not correct, as
unaware-leaves is the one defining the value.  Maybe “This specification
uses…” would be more appropriate.

Rahul:  Please don’t submit anything yet.  Because IANA already created the
registry (from the efficient-npdao draft), I want to check with them what
is the right thing to do: if we just delete the registry, or if we need to
leave it and deprecate it somehow.

Thanks!

Alvaro.

On October 28, 2020 at 11:06:39 AM, Pascal Thubert (pthubert) (
[email-masked]) wrote:

Hello Rahul

I believe that you need to indicate that the status is a RPL Status and
refer to section 6.5.1. of RPL " Format of the DAO-ACK Base Object". I'm
sure Alvaro will propose an improvement but my knee jerk:

Before:

Status: Indicates the completion status. Section 12.5 of
[I-D.ietf-roll-unaware-leaves] defines the status values. A value of 0 is
defined as unqualified acceptance. A value of 1 is defined as "No
routing-entry for the indicated Target found".

After:

Status: RPL Status indicating the completion. The RPL Status is defined in
section 6.5.1. of [RFC 6550] and updated in
section 6.3 of [I-D.ietf-roll-unaware-leaves]. This specification adds the
RPL rejection value ('E' flag set and 'A' flag not set) of 1, defined as
"No routing-entry for the indicated Target found".

Works?

Take care;

Pascal

> I am mostly clear on the changes required. Please find attached an
HTML-diff
> The only concern for me was if we remove the registry where would the
Status
> > Attracting your attention on the particular point below in Alvaro’s AD
review
> of unaware leaves:

---

From: Rahul Jadhav <[email-masked]>
Date: Wed, 28 Oct 2020 21:14:53 +0530

Thanks, Pascal, Alvaro for the edits.

@Pascal Thubert, Regarding "('E' flag set and 'A' flag not set)", this
may confuse the reader and also may not be relevant for this spec
since it is ok for an implementer to simply use 0/1 as a Status value
without the understanding of E/A flags in unaware-leaves. Can we skip
that part since anyways we are referencing unaware-leaves?

@Alvaro Retana, I will not submit unless explicitly told to do.

Thanks,
Rahul

On Wed, 28 Oct 2020 at 20:47, Alvaro Retana <[email-masked]> wrote:
>
>
> Hi!
>
> The last part (“This specification adds…”) is not correct, as unaware-leaves is the one defining the value.  Maybe “This specification uses…” would be more appropriate.
>
>
> Rahul:  Please don’t submit anything yet.  Because IANA already created the registry (from the efficient-npdao draft), I want to check with them what is the right thing to do: if we just delete the registry, or if we need to leave it and deprecate it somehow.
>
> Thanks!
>
> Alvaro.
>
> On October 28, 2020 at 11:06:39 AM, Pascal Thubert (pthubert) ([email-masked]) wrote:
>
> Hello Rahul
>

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Wed, 28 Oct 2020 16:12:44 +0000

Hello Alvaro

I disagree, the code 1 is added by DCO. Unaware leaves modifies the format and creates the registry since neither RPL nor DCO did.

This appears to be the simple thing to do. The more complex / cleaner thing to do would be that unaware leaves comes first  and creates the registry as of ow but without the value of 1. Then DCO adds a IANA entry that adds the value of 1. That’s a bit more IANA work.

In any fashion DCO needs to indicate that this is a rejection code, I’ll answer to Rahul on that.

Keep safe!

Pascal

From: Alvaro Retana <[email-masked]>
Sent: mercredi 28 octobre 2020 16:17
To: Pascal Thubert (pthubert) <[email-masked]>; Rahul Jadhav <[email-masked]>
Cc: [email-masked]; Routing Over Low power and Lossy networks <[email-masked]>
Subject: RE: Deprecating DCO status

Hi!

Thanks!

Alvaro.

On October 28, 2020 at 11:06:39 AM, Pascal Thubert (pthubert) ([email-masked]<mailto:[email-masked]>) wrote:
Hello Rahul

Before:

After:

Works?

Take care;

Pascal

> From: Rahul Jadhav <[email-masked]<mailto:[email-masked]>>
> To: Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>
> Cc: Alvaro Retana <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; Routing
> Over Low power and Lossy networks <[email-masked]<mailto:[email-masked]>>
> <[email-masked]<mailto:[email-masked]>> wrote:
> >
> > Hello Rahul:
> >
> >
> >

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Wed, 28 Oct 2020 16:21:43 +0000

Hello Rahul

> @Pascal Thubert, Regarding "('E' flag set and 'A' flag not set)", this may
> confuse the reader and also may not be relevant for this spec since it is ok for
> an implementer to simply use 0/1 as a Status value without the understanding
> of E/A flags in unaware-leaves. Can we skip that part since anyways we are
> referencing unaware-leaves?

RFC 6550 specifies that values >= 128 are rejection. The 'E' flag is backward compatible. The reason why I mention it is that DCO has a normative ref to unuaware leaves, so it needs to implement the new RPL Status, meaning that it needs to indicates the setting of the 'E' and 'A' flags for each status it defines.

My question to you is whether DCO status code 1 was a rejection or not. If it was a rejection, then the RPL Status value per RFC 6550 should have been 129; in the new format it is 1 again, but with the 'E' flag set. This si what https://tools.ietf.org/html/draft-ietf-roll-unaware-leaves-22#section-12.5 assumes.

If it is a warning, then a value of 1 is OK but still I'd mention the E and A flags for completeness, both set to 0. 
If so then the IANA declaration in unaware-leaves has to change.

I tend to think that I should remove 

        | 1     | No routing-entry for the | [EFFICIENT-NPDAO] |
         |       | indicated Target found   |                  

From the initialization of the IANA section and let you define it as a new entry in the registry in DCO.

What do you all think?

Pascal

---

From: Alvaro Retana <[email-masked]>
Date: Wed, 28 Oct 2020 11:05:27 -0700

Ok…if the registry is created by unaware-leaves, and the “no routing entry”
value is added by npdao, we should be ok.

Alvaro.

On October 28, 2020 at 12:22:09 PM, Pascal Thubert (pthubert) (
[email-masked]) wrote:

Hello Rahul

> @Pascal Thubert, Regarding "('E' flag set and 'A' flag not set)", this
may
> referencing unaware-leaves?

RFC 6550 specifies that values >= 128 are rejection. The 'E' flag is
backward compatible. The reason why I mention it is that DCO has a
normative ref to unuaware leaves, so it needs to implement the new RPL
Status, meaning that it needs to indicates the setting of the 'E' and 'A'
flags for each status it defines.

My question to you is whether DCO status code 1 was a rejection or not. If
it was a rejection, then the RPL Status value per RFC 6550 should have been
129; in the new format it is 1 again, but with the 'E' flag set. This si
what
https://tools.ietf.org/html/draft-ietf-roll-unaware-leaves-22#section-12.5
assumes.

If it is a warning, then a value of 1 is OK but still I'd mention the E and
A flags for completeness, both set to 0.
If so then the IANA declaration in unaware-leaves has to change.

What do you all think?

Pascal

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Wed, 28 Oct 2020 19:48:14 +0000

Let’s do this !

Regards,

Pascal

Le 28 oct. 2020 à 19:05, Alvaro Retana <[email-masked]> a écrit :

Ok…if the registry is created by unaware-leaves, and the “no routing entry” value is added by npdao, we should be ok.

Alvaro.

On October 28, 2020 at 12:22:09 PM, Pascal Thubert (pthubert) ([email-masked]<mailto:[email-masked]>) wrote:

Hello Rahul

What do you all think?

Pascal

---

From: Rahul Jadhav <[email-masked]>
Date: Thu, 29 Oct 2020 16:25:24 +0530

I am not sure if I understand it correctly.
Is the proposal to update the IANA registry for "no routing entry"
value by NPDAO? That is, I should keep the IANA section in NPDAO but
mention it is an update to (not create of) the registry and keep a
reference to unaware leaves?
Does this also mean that there will be an update to Section 12.5 of
Unaware leaves?

Regards,
Rahul

On Thu, 29 Oct 2020 at 01:18, Pascal Thubert (pthubert)
<[email-masked]> wrote:
> On October 28, 2020 at 12:22:09 PM, Pascal Thubert (pthubert) ([email-masked]) wrote:
>
> Hello Rahul
>

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Thu, 29 Oct 2020 11:24:02 +0000

Yes Rahul, 

This is how I suggest we do.

Keep safe !

Pascal

> Le 29 oct. 2020 à 11:55, Rahul Jadhav <[email-masked]> a écrit :
>